## Script (Python) "edit_boxtool_settings"
##parameters=REQUEST
##title=

boxtool = context.portal_boxtool
memtool = context.portal_membership

if not REQUEST.has_key('itemtypes'):
    REQUEST.set('itemtypes', None)
if not REQUEST.has_key('formattypes'):
    REQUEST.set('formattypes', None)

if REQUEST.has_key('use_language'):
    use_language = 1
else:
    use_language = 0

status_msg = ''
close = 'false'
if memtool.getAuthenticatedMember().has_role('Manager'):
    if REQUEST.has_key('add_box'):
        boxtool.addBoxItem(title='New Box Item')
        status_msg = 'Added+a+new+box+item'
    elif REQUEST.has_key('add_calendar'):
        boxtool.addCalendarBox(title='New Calendar Box')
        status_msg = 'Added+a+new+calendar+box'
    elif REQUEST.has_key('edit_item'):
        boxtool.editBoxItem(id=REQUEST['itemid']
                          , title=REQUEST['title']
                          , itemCount=REQUEST['itemCount']
                          , subjects=REQUEST['subjects']
                          , types=REQUEST['itemtypes']
                          , sort_criteria=REQUEST['sortcriteria']
                          , format_types=REQUEST['formattypes']
                          , language=REQUEST['sel_language']
                          , use_language=use_language)
        status_msg = 'Box+item+updated'
        close = 'true'
    elif REQUEST.has_key('edit_tab'):
        boxtool.editTabItem(id=REQUEST['itemid']
                          , title=REQUEST['title']
                          , type=REQUEST['tabtype']
                          , link=REQUEST['link']
                          , boxid=REQUEST['boxid']
                          , language=REQUEST['sel_language'])
        status_msg = 'Tab+item+updated'
        close = 'true'
    elif REQUEST.has_key('moveup'):
        boxtool.moveupBoxItem(REQUEST['itemindex'])
        status_msg = 'Box+item+moved+up'
    elif REQUEST.has_key('movedown'):
        boxtool.movedownBoxItem(REQUEST['itemindex'])
        status_msg = 'Box+item+moved+down'
    elif REQUEST.has_key('delete'):
        boxtool.deleteBoxItem(REQUEST['itemindex'])
        status_msg = 'Box+item+deleted'
    elif REQUEST.has_key('set_slots'):
        boxitems = boxtool.listBoxItems()
        midleftslot = []
        midrightslot = []
        rightslot = []
        for item in boxitems:
            itemid = item.getId()
            requeststr = 'box_%s' % itemid
            if REQUEST.has_key(requeststr):
                slotname = REQUEST[requeststr]
                if slotname == 'midleft':
                    midleftslot.append(itemid)
                elif slotname == 'midright':
                    midrightslot.append(itemid)
                elif slotname == 'right':
                    rightslot.append(itemid)
        boxtool.setBoxSlots(midleftslot, midrightslot, rightslot)
        status_msg = 'Box+slots+updated'
    elif REQUEST.has_key('add_tab'):
        boxtool.addTabItem('New Tab')
        status_msg = 'Added+a+new+tab'
    elif REQUEST.has_key('moveupTab'):
        boxtool.moveupTabItem(REQUEST['itemindex'])
        status_msg = 'Tab+item+moved+up'
    elif REQUEST.has_key('movedownTab'):
        boxtool.movedownTabItem(REQUEST['itemindex'])
        status_msg = 'Tab+item+moved+down'
    elif REQUEST.has_key('delete_tab'):
        boxtool.deleteTabItem(REQUEST['itemindex'])
        status_msg = 'Tab+item+deleted'
    else:
        status_msg = 'No+action+selected'
else:
    status_msg = 'Only+managers+are+allowed+to+do+this'
    
context.REQUEST.RESPONSE.redirect(context.absolute_url() + '/setup_boxtool?portal_status_message=' + status_msg + '&closewindow=' + close)
